Linux Audio

Check our new training course

Loading...
v6.8
  1#!/bin/sh
  2# SPDX-License-Identifier: GPL-2.0
  3#
  4# Tests whether a suitable Rust toolchain is available.
  5
  6set -e
  7
  8min_tool_version=$(dirname $0)/min-tool-version.sh
  9
 10# Convert the version string x.y.z to a canonical up-to-7-digits form.
 11#
 12# Note that this function uses one more digit (compared to other
 13# instances in other version scripts) to give a bit more space to
 14# `rustc` since it will reach 1.100.0 in late 2026.
 15get_canonical_version()
 16{
 17	IFS=.
 18	set -- $1
 19	echo $((100000 * $1 + 100 * $2 + $3))
 20}
 21
 22# Print a reference to the Quick Start guide in the documentation.
 23print_docs_reference()
 24{
 25	echo >&2 "***"
 26	echo >&2 "*** Please see Documentation/rust/quick-start.rst for details"
 27	echo >&2 "*** on how to set up the Rust support."
 28	echo >&2 "***"
 29}
 30
 31# Print an explanation about the fact that the script is meant to be called from Kbuild.
 32print_kbuild_explanation()
 33{
 34	echo >&2 "***"
 35	echo >&2 "*** This script is intended to be called from Kbuild."
 36	echo >&2 "*** Please use the 'rustavailable' target to call it instead."
 37	echo >&2 "*** Otherwise, the results may not be meaningful."
 38	exit 1
 39}
 40
 41# If the script fails for any reason, or if there was any warning, then
 42# print a reference to the documentation on exit.
 43warning=0
 44trap 'if [ $? -ne 0 ] || [ $warning -ne 0 ]; then print_docs_reference; fi' EXIT
 45
 46# Check that the expected environment variables are set.
 47if [ -z "${RUSTC+x}" ]; then
 48	echo >&2 "***"
 49	echo >&2 "*** Environment variable 'RUSTC' is not set."
 50	print_kbuild_explanation
 51fi
 52
 53if [ -z "${BINDGEN+x}" ]; then
 54	echo >&2 "***"
 55	echo >&2 "*** Environment variable 'BINDGEN' is not set."
 56	print_kbuild_explanation
 57fi
 58
 59if [ -z "${CC+x}" ]; then
 60	echo >&2 "***"
 61	echo >&2 "*** Environment variable 'CC' is not set."
 62	print_kbuild_explanation
 63fi
 64
 65# Check that the Rust compiler exists.
 66if ! command -v "$RUSTC" >/dev/null; then
 67	echo >&2 "***"
 68	echo >&2 "*** Rust compiler '$RUSTC' could not be found."
 69	echo >&2 "***"
 70	exit 1
 71fi
 72
 73# Check that the Rust bindings generator exists.
 74if ! command -v "$BINDGEN" >/dev/null; then
 75	echo >&2 "***"
 76	echo >&2 "*** Rust bindings generator '$BINDGEN' could not be found."
 77	echo >&2 "***"
 78	exit 1
 79fi
 80
 81# Check that the Rust compiler version is suitable.
 82#
 83# Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
 84rust_compiler_output=$( \
 85	LC_ALL=C "$RUSTC" --version 2>/dev/null
 86) || rust_compiler_code=$?
 87if [ -n "$rust_compiler_code" ]; then
 88	echo >&2 "***"
 89	echo >&2 "*** Running '$RUSTC' to check the Rust compiler version failed with"
 90	echo >&2 "*** code $rust_compiler_code. See output and docs below for details:"
 91	echo >&2 "***"
 92	echo >&2 "$rust_compiler_output"
 93	echo >&2 "***"
 94	exit 1
 95fi
 96rust_compiler_version=$( \
 97	echo "$rust_compiler_output" \
 98		| sed -nE '1s:.*rustc ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
 99)
100if [ -z "$rust_compiler_version" ]; then
101	echo >&2 "***"
102	echo >&2 "*** Running '$RUSTC' to check the Rust compiler version did not return"
103	echo >&2 "*** an expected output. See output and docs below for details:"
104	echo >&2 "***"
105	echo >&2 "$rust_compiler_output"
106	echo >&2 "***"
107	exit 1
108fi
109rust_compiler_min_version=$($min_tool_version rustc)
110rust_compiler_cversion=$(get_canonical_version $rust_compiler_version)
111rust_compiler_min_cversion=$(get_canonical_version $rust_compiler_min_version)
112if [ "$rust_compiler_cversion" -lt "$rust_compiler_min_cversion" ]; then
113	echo >&2 "***"
114	echo >&2 "*** Rust compiler '$RUSTC' is too old."
115	echo >&2 "***   Your version:    $rust_compiler_version"
116	echo >&2 "***   Minimum version: $rust_compiler_min_version"
117	echo >&2 "***"
118	exit 1
119fi
120if [ "$rust_compiler_cversion" -gt "$rust_compiler_min_cversion" ]; then
121	echo >&2 "***"
122	echo >&2 "*** Rust compiler '$RUSTC' is too new. This may or may not work."
123	echo >&2 "***   Your version:     $rust_compiler_version"
124	echo >&2 "***   Expected version: $rust_compiler_min_version"
125	echo >&2 "***"
126	warning=1
127fi
128
129# Check that the Rust bindings generator is suitable.
130#
131# Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
 
 
 
 
132rust_bindings_generator_output=$( \
133	LC_ALL=C "$BINDGEN" --version 2>/dev/null
134) || rust_bindings_generator_code=$?
135if [ -n "$rust_bindings_generator_code" ]; then
136	echo >&2 "***"
137	echo >&2 "*** Running '$BINDGEN' to check the Rust bindings generator version failed with"
138	echo >&2 "*** code $rust_bindings_generator_code. See output and docs below for details:"
139	echo >&2 "***"
140	echo >&2 "$rust_bindings_generator_output"
141	echo >&2 "***"
142	exit 1
143fi
144rust_bindings_generator_version=$( \
145	echo "$rust_bindings_generator_output" \
146		| sed -nE '1s:.*bindgen ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
147)
148if [ -z "$rust_bindings_generator_version" ]; then
149	echo >&2 "***"
150	echo >&2 "*** Running '$BINDGEN' to check the bindings generator version did not return"
151	echo >&2 "*** an expected output. See output and docs below for details:"
152	echo >&2 "***"
153	echo >&2 "$rust_bindings_generator_output"
154	echo >&2 "***"
155	exit 1
156fi
157rust_bindings_generator_min_version=$($min_tool_version bindgen)
158rust_bindings_generator_cversion=$(get_canonical_version $rust_bindings_generator_version)
159rust_bindings_generator_min_cversion=$(get_canonical_version $rust_bindings_generator_min_version)
160if [ "$rust_bindings_generator_cversion" -lt "$rust_bindings_generator_min_cversion" ]; then
161	echo >&2 "***"
162	echo >&2 "*** Rust bindings generator '$BINDGEN' is too old."
163	echo >&2 "***   Your version:    $rust_bindings_generator_version"
164	echo >&2 "***   Minimum version: $rust_bindings_generator_min_version"
165	echo >&2 "***"
166	exit 1
167fi
168if [ "$rust_bindings_generator_cversion" -gt "$rust_bindings_generator_min_cversion" ]; then
169	echo >&2 "***"
170	echo >&2 "*** Rust bindings generator '$BINDGEN' is too new. This may or may not work."
171	echo >&2 "***   Your version:     $rust_bindings_generator_version"
172	echo >&2 "***   Expected version: $rust_bindings_generator_min_version"
173	echo >&2 "***"
174	warning=1
 
 
 
 
 
175fi
176
177# Check that the `libclang` used by the Rust bindings generator is suitable.
178#
179# In order to do that, first invoke `bindgen` to get the `libclang` version
180# found by `bindgen`. This step may already fail if, for instance, `libclang`
181# is not found, thus inform the user in such a case.
182bindgen_libclang_output=$( \
183	LC_ALL=C "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang.h 2>&1 >/dev/null
184) || bindgen_libclang_code=$?
185if [ -n "$bindgen_libclang_code" ]; then
186	echo >&2 "***"
187	echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
188	echo >&2 "*** bindings generator) failed with code $bindgen_libclang_code. This may be caused by"
189	echo >&2 "*** a failure to locate libclang. See output and docs below for details:"
190	echo >&2 "***"
191	echo >&2 "$bindgen_libclang_output"
192	echo >&2 "***"
193	exit 1
194fi
195
196# `bindgen` returned successfully, thus use the output to check that the version
197# of the `libclang` found by the Rust bindings generator is suitable.
198#
199# Unlike other version checks, note that this one does not necessarily appear
200# in the first line of the output, thus no `sed` address is provided.
201bindgen_libclang_version=$( \
202	echo "$bindgen_libclang_output" \
203		| sed -nE 's:.*clang version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
204)
205if [ -z "$bindgen_libclang_version" ]; then
206	echo >&2 "***"
207	echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
208	echo >&2 "*** bindings generator) did not return an expected output. See output"
209	echo >&2 "*** and docs below for details:"
210	echo >&2 "***"
211	echo >&2 "$bindgen_libclang_output"
212	echo >&2 "***"
213	exit 1
214fi
215bindgen_libclang_min_version=$($min_tool_version llvm)
216bindgen_libclang_cversion=$(get_canonical_version $bindgen_libclang_version)
217bindgen_libclang_min_cversion=$(get_canonical_version $bindgen_libclang_min_version)
218if [ "$bindgen_libclang_cversion" -lt "$bindgen_libclang_min_cversion" ]; then
219	echo >&2 "***"
220	echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN') is too old."
221	echo >&2 "***   Your version:    $bindgen_libclang_version"
222	echo >&2 "***   Minimum version: $bindgen_libclang_min_version"
223	echo >&2 "***"
224	exit 1
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
225fi
226
227# If the C compiler is Clang, then we can also check whether its version
228# matches the `libclang` version used by the Rust bindings generator.
229#
230# In the future, we might be able to perform a full version check, see
231# https://github.com/rust-lang/rust-bindgen/issues/2138.
232cc_name=$($(dirname $0)/cc-version.sh $CC | cut -f1 -d' ')
233if [ "$cc_name" = Clang ]; then
234	clang_version=$( \
235		LC_ALL=C $CC --version 2>/dev/null \
236			| sed -nE '1s:.*version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
237	)
238	if [ "$clang_version" != "$bindgen_libclang_version" ]; then
239		echo >&2 "***"
240		echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN')"
241		echo >&2 "*** version does not match Clang's. This may be a problem."
242		echo >&2 "***   libclang version: $bindgen_libclang_version"
243		echo >&2 "***   Clang version:    $clang_version"
244		echo >&2 "***"
245		warning=1
246	fi
247fi
248
249# Check that the source code for the `core` standard library exists.
250#
251# `$KRUSTFLAGS` is passed in case the user added `--sysroot`.
252rustc_sysroot=$("$RUSTC" $KRUSTFLAGS --print sysroot)
253rustc_src=${RUST_LIB_SRC:-"$rustc_sysroot/lib/rustlib/src/rust/library"}
254rustc_src_core="$rustc_src/core/src/lib.rs"
255if [ ! -e "$rustc_src_core" ]; then
256	echo >&2 "***"
257	echo >&2 "*** Source code for the 'core' standard library could not be found"
258	echo >&2 "*** at '$rustc_src_core'."
259	echo >&2 "***"
260	exit 1
261fi
v6.13.7
  1#!/bin/sh
  2# SPDX-License-Identifier: GPL-2.0
  3#
  4# Tests whether a suitable Rust toolchain is available.
  5
  6set -e
  7
  8min_tool_version=$(dirname $0)/min-tool-version.sh
  9
 10# Convert the version string x.y.z to a canonical up-to-7-digits form.
 11#
 12# Note that this function uses one more digit (compared to other
 13# instances in other version scripts) to give a bit more space to
 14# `rustc` since it will reach 1.100.0 in late 2026.
 15get_canonical_version()
 16{
 17	IFS=.
 18	set -- $1
 19	echo $((100000 * $1 + 100 * $2 + $3))
 20}
 21
 22# Print a reference to the Quick Start guide in the documentation.
 23print_docs_reference()
 24{
 25	echo >&2 "***"
 26	echo >&2 "*** Please see Documentation/rust/quick-start.rst for details"
 27	echo >&2 "*** on how to set up the Rust support."
 28	echo >&2 "***"
 29}
 30
 31# Print an explanation about the fact that the script is meant to be called from Kbuild.
 32print_kbuild_explanation()
 33{
 34	echo >&2 "***"
 35	echo >&2 "*** This script is intended to be called from Kbuild."
 36	echo >&2 "*** Please use the 'rustavailable' target to call it instead."
 37	echo >&2 "*** Otherwise, the results may not be meaningful."
 38	exit 1
 39}
 40
 41# If the script fails for any reason, or if there was any warning, then
 42# print a reference to the documentation on exit.
 43warning=0
 44trap 'if [ $? -ne 0 ] || [ $warning -ne 0 ]; then print_docs_reference; fi' EXIT
 45
 46# Check that the expected environment variables are set.
 47if [ -z "${RUSTC+x}" ]; then
 48	echo >&2 "***"
 49	echo >&2 "*** Environment variable 'RUSTC' is not set."
 50	print_kbuild_explanation
 51fi
 52
 53if [ -z "${BINDGEN+x}" ]; then
 54	echo >&2 "***"
 55	echo >&2 "*** Environment variable 'BINDGEN' is not set."
 56	print_kbuild_explanation
 57fi
 58
 59if [ -z "${CC+x}" ]; then
 60	echo >&2 "***"
 61	echo >&2 "*** Environment variable 'CC' is not set."
 62	print_kbuild_explanation
 63fi
 64
 65# Check that the Rust compiler exists.
 66if ! command -v "$RUSTC" >/dev/null; then
 67	echo >&2 "***"
 68	echo >&2 "*** Rust compiler '$RUSTC' could not be found."
 69	echo >&2 "***"
 70	exit 1
 71fi
 72
 73# Check that the Rust bindings generator exists.
 74if ! command -v "$BINDGEN" >/dev/null; then
 75	echo >&2 "***"
 76	echo >&2 "*** Rust bindings generator '$BINDGEN' could not be found."
 77	echo >&2 "***"
 78	exit 1
 79fi
 80
 81# Check that the Rust compiler version is suitable.
 82#
 83# Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
 84rust_compiler_output=$( \
 85	LC_ALL=C "$RUSTC" --version 2>/dev/null
 86) || rust_compiler_code=$?
 87if [ -n "$rust_compiler_code" ]; then
 88	echo >&2 "***"
 89	echo >&2 "*** Running '$RUSTC' to check the Rust compiler version failed with"
 90	echo >&2 "*** code $rust_compiler_code. See output and docs below for details:"
 91	echo >&2 "***"
 92	echo >&2 "$rust_compiler_output"
 93	echo >&2 "***"
 94	exit 1
 95fi
 96rust_compiler_version=$( \
 97	echo "$rust_compiler_output" \
 98		| sed -nE '1s:.*rustc ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
 99)
100if [ -z "$rust_compiler_version" ]; then
101	echo >&2 "***"
102	echo >&2 "*** Running '$RUSTC' to check the Rust compiler version did not return"
103	echo >&2 "*** an expected output. See output and docs below for details:"
104	echo >&2 "***"
105	echo >&2 "$rust_compiler_output"
106	echo >&2 "***"
107	exit 1
108fi
109rust_compiler_min_version=$($min_tool_version rustc)
110rust_compiler_cversion=$(get_canonical_version $rust_compiler_version)
111rust_compiler_min_cversion=$(get_canonical_version $rust_compiler_min_version)
112if [ "$rust_compiler_cversion" -lt "$rust_compiler_min_cversion" ]; then
113	echo >&2 "***"
114	echo >&2 "*** Rust compiler '$RUSTC' is too old."
115	echo >&2 "***   Your version:    $rust_compiler_version"
116	echo >&2 "***   Minimum version: $rust_compiler_min_version"
117	echo >&2 "***"
118	exit 1
119fi
 
 
 
 
 
 
 
 
120
121# Check that the Rust bindings generator is suitable.
122#
123# Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
124#
125# The dummy parameter `workaround-for-0.69.0` is required to support 0.69.0
126# (https://github.com/rust-lang/rust-bindgen/pull/2678). It can be removed when
127# the minimum version is upgraded past that (0.69.1 already fixed the issue).
128rust_bindings_generator_output=$( \
129	LC_ALL=C "$BINDGEN" --version workaround-for-0.69.0 2>/dev/null
130) || rust_bindings_generator_code=$?
131if [ -n "$rust_bindings_generator_code" ]; then
132	echo >&2 "***"
133	echo >&2 "*** Running '$BINDGEN' to check the Rust bindings generator version failed with"
134	echo >&2 "*** code $rust_bindings_generator_code. See output and docs below for details:"
135	echo >&2 "***"
136	echo >&2 "$rust_bindings_generator_output"
137	echo >&2 "***"
138	exit 1
139fi
140rust_bindings_generator_version=$( \
141	echo "$rust_bindings_generator_output" \
142		| sed -nE '1s:.*bindgen ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
143)
144if [ -z "$rust_bindings_generator_version" ]; then
145	echo >&2 "***"
146	echo >&2 "*** Running '$BINDGEN' to check the bindings generator version did not return"
147	echo >&2 "*** an expected output. See output and docs below for details:"
148	echo >&2 "***"
149	echo >&2 "$rust_bindings_generator_output"
150	echo >&2 "***"
151	exit 1
152fi
153rust_bindings_generator_min_version=$($min_tool_version bindgen)
154rust_bindings_generator_cversion=$(get_canonical_version $rust_bindings_generator_version)
155rust_bindings_generator_min_cversion=$(get_canonical_version $rust_bindings_generator_min_version)
156if [ "$rust_bindings_generator_cversion" -lt "$rust_bindings_generator_min_cversion" ]; then
157	echo >&2 "***"
158	echo >&2 "*** Rust bindings generator '$BINDGEN' is too old."
159	echo >&2 "***   Your version:    $rust_bindings_generator_version"
160	echo >&2 "***   Minimum version: $rust_bindings_generator_min_version"
161	echo >&2 "***"
162	exit 1
163fi
164if [ "$rust_bindings_generator_cversion" -eq 6600 ] ||
165	[ "$rust_bindings_generator_cversion" -eq 6601 ]; then
166	# Distributions may have patched the issue (e.g. Debian did).
167	if ! "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_0_66.h >/dev/null; then
168		echo >&2 "***"
169		echo >&2 "*** Rust bindings generator '$BINDGEN' versions 0.66.0 and 0.66.1 may not"
170		echo >&2 "*** work due to a bug (https://github.com/rust-lang/rust-bindgen/pull/2567),"
171		echo >&2 "*** unless patched (like Debian's)."
172		echo >&2 "***   Your version:     $rust_bindings_generator_version"
173		echo >&2 "***"
174		warning=1
175	fi
176fi
177
178# Check that the `libclang` used by the Rust bindings generator is suitable.
179#
180# In order to do that, first invoke `bindgen` to get the `libclang` version
181# found by `bindgen`. This step may already fail if, for instance, `libclang`
182# is not found, thus inform the user in such a case.
183bindgen_libclang_output=$( \
184	LC_ALL=C "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang.h 2>&1 >/dev/null
185) || bindgen_libclang_code=$?
186if [ -n "$bindgen_libclang_code" ]; then
187	echo >&2 "***"
188	echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
189	echo >&2 "*** bindings generator) failed with code $bindgen_libclang_code. This may be caused by"
190	echo >&2 "*** a failure to locate libclang. See output and docs below for details:"
191	echo >&2 "***"
192	echo >&2 "$bindgen_libclang_output"
193	echo >&2 "***"
194	exit 1
195fi
196
197# `bindgen` returned successfully, thus use the output to check that the version
198# of the `libclang` found by the Rust bindings generator is suitable.
199#
200# Unlike other version checks, note that this one does not necessarily appear
201# in the first line of the output, thus no `sed` address is provided.
202bindgen_libclang_version=$( \
203	echo "$bindgen_libclang_output" \
204		| sed -nE 's:.*clang version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
205)
206if [ -z "$bindgen_libclang_version" ]; then
207	echo >&2 "***"
208	echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
209	echo >&2 "*** bindings generator) did not return an expected output. See output"
210	echo >&2 "*** and docs below for details:"
211	echo >&2 "***"
212	echo >&2 "$bindgen_libclang_output"
213	echo >&2 "***"
214	exit 1
215fi
216bindgen_libclang_min_version=$($min_tool_version llvm)
217bindgen_libclang_cversion=$(get_canonical_version $bindgen_libclang_version)
218bindgen_libclang_min_cversion=$(get_canonical_version $bindgen_libclang_min_version)
219if [ "$bindgen_libclang_cversion" -lt "$bindgen_libclang_min_cversion" ]; then
220	echo >&2 "***"
221	echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN') is too old."
222	echo >&2 "***   Your version:    $bindgen_libclang_version"
223	echo >&2 "***   Minimum version: $bindgen_libclang_min_version"
224	echo >&2 "***"
225	exit 1
226fi
227
228if [ "$bindgen_libclang_cversion" -ge 1900100 ] &&
229	[ "$rust_bindings_generator_cversion" -lt 6905 ]; then
230	# Distributions may have patched the issue (e.g. Debian did).
231	if ! "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang_concat.h | grep -q foofoo; then
232		echo >&2 "***"
233		echo >&2 "*** Rust bindings generator '$BINDGEN' < 0.69.5 together with libclang >= 19.1"
234		echo >&2 "*** may not work due to a bug (https://github.com/rust-lang/rust-bindgen/pull/2824),"
235		echo >&2 "*** unless patched (like Debian's)."
236		echo >&2 "***   Your bindgen version:  $rust_bindings_generator_version"
237		echo >&2 "***   Your libclang version: $bindgen_libclang_version"
238		echo >&2 "***"
239		warning=1
240	fi
241fi
242
243# If the C compiler is Clang, then we can also check whether its version
244# matches the `libclang` version used by the Rust bindings generator.
245#
246# In the future, we might be able to perform a full version check, see
247# https://github.com/rust-lang/rust-bindgen/issues/2138.
248cc_name=$($(dirname $0)/cc-version.sh $CC | cut -f1 -d' ')
249if [ "$cc_name" = Clang ]; then
250	clang_version=$( \
251		LC_ALL=C $CC --version 2>/dev/null \
252			| sed -nE '1s:.*version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
253	)
254	if [ "$clang_version" != "$bindgen_libclang_version" ]; then
255		echo >&2 "***"
256		echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN')"
257		echo >&2 "*** version does not match Clang's. This may be a problem."
258		echo >&2 "***   libclang version: $bindgen_libclang_version"
259		echo >&2 "***   Clang version:    $clang_version"
260		echo >&2 "***"
261		warning=1
262	fi
263fi
264
265# Check that the source code for the `core` standard library exists.
266#
267# `$KRUSTFLAGS` is passed in case the user added `--sysroot`.
268rustc_sysroot=$("$RUSTC" $KRUSTFLAGS --print sysroot)
269rustc_src=${RUST_LIB_SRC:-"$rustc_sysroot/lib/rustlib/src/rust/library"}
270rustc_src_core="$rustc_src/core/src/lib.rs"
271if [ ! -e "$rustc_src_core" ]; then
272	echo >&2 "***"
273	echo >&2 "*** Source code for the 'core' standard library could not be found"
274	echo >&2 "*** at '$rustc_src_core'."
275	echo >&2 "***"
276	exit 1
277fi